# TensorFlow Research Models

This folder contains machine learning models implemented by researchers in [TensorFlow](https://tensorflow.org). The models are maintained by their respective authors. To propose a model for inclusion, please submit a pull request.

Currently, the models are compatible with TensorFlow 1.0 or later. If you are running TensorFlow 0.12 or earlier, please [upgrade your installation](https://www.tensorflow.org/install).

## Models

* [adversarial\_crypto](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/adversarial_crypto/README.md): protecting communications with

  adversarial neural cryptography.
* [adversarial\_text](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/adversarial_text/README.md): semi-supervised sequence learning with

  adversarial training.
* [attention\_ocr](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/attention_ocr/README.md): a model for real-world image text

  extraction.
* [audioset](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/audioset/README.md): Models and supporting code for use with

  [AudioSet](http://g.co/audioset).
* [autoencoder](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/autoencoder/README.md): various autoencoders.
* [brain\_coder](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/brain_coder/README.md): Program synthesis with reinforcement learning.
* [cognitive\_mapping\_and\_planning](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/cognitive_mapping_and_planning/README.md):

  implementation of a spatial memory based mapping and planning architecture

  for visual navigation.
* [compression](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/compression/README.md): compressing and decompressing images using a

  pre-trained Residual GRU network.
* [deeplab](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/deeplab/README.md): deep labelling for semantic image segmentation.
* [delf](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/delf/README.md): deep local features for image matching and retrieval.
* [differential\_privacy](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/differential_privacy/README.md): differential privacy for training

  data.
* [domain\_adaptation](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/domain_adaptation/README.md): domain separation networks.
* [gan](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/gan/README.md): generative adversarial networks.
* [im2txt](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/im2txt/README.md): image-to-text neural network for image captioning.
* [inception](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/inception/README.md): deep convolutional networks for computer vision.
* [learning\_to\_remember\_rare\_events](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/learning_to_remember_rare_events/README.md): a

  large-scale life-long memory module for use in deep learning.
* [learning\_unsupervised\_learning](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/learning_unsupervised_learning/README.md): a

  meta-learned unsupervised learning update rule.
* [lexnet\_nc](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/lexnet_nc/README.md): a distributed model for noun compound relationship

  classification.
* [lfads](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/lfads/README.md): sequential variational autoencoder for analyzing

  neuroscience data.
* [lm\_1b](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/lm_1b/README.md): language modeling on the one billion word benchmark.
* [maskgan](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/maskgan/README.md): text generation with GANs.
* [namignizer](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/namignizer/README.md): recognize and generate names.
* [neural\_gpu](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/neural_gpu/README.md): highly parallel neural computer.
* [neural\_programmer](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/neural_programmer/README.md): neural network augmented with logic

  and mathematic operations.
* [next\_frame\_prediction](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/next_frame_prediction/README.md): probabilistic future frame

  synthesis via cross convolutional networks.
* [object\_detection](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/object_detection/README.md): localizing and identifying multiple

  objects in a single image.
* [pcl\_rl](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/pcl_rl/README.md): code for several reinforcement learning algorithms,

  including Path Consistency Learning.
* [ptn](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/ptn/README.md): perspective transformer nets for 3D object reconstruction.
* [qa\_kg](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/qa_kg/README.md): module networks for question answering on knowledge graphs.
* [real\_nvp](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/real_nvp/README.md): density estimation using real-valued non-volume

  preserving (real NVP) transformations.
* [rebar](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/rebar/README.md): low-variance, unbiased gradient estimates for discrete

  latent variable models.
* [resnet](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/resnet/README.md): deep and wide residual networks.
* [skip\_thoughts](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/skip_thoughts/README.md): recurrent neural network sentence-to-vector

  encoder.
* [slim](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/slim/README.md): image classification models in TF-Slim.
* [street](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/street/README.md): identify the name of a street (in France) from an image

  using a Deep RNN.
* [swivel](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/swivel/README.md): the Swivel algorithm for generating word embeddings.
* [syntaxnet](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/syntaxnet/README.md): neural models of natural language syntax.
* [tcn](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/tcn/README.md): Self-supervised representation learning from multi-view video.
* [textsum](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/textsum/README.md): sequence-to-sequence with attention model for text

  summarization.
* [transformer](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/transformer/README.md): spatial transformer network, which allows the

  spatial manipulation of data within the network.
* [video\_prediction](https://github.com/deepdrive/deepdrive/tree/c64371bd9b652dbaaa84f868a7e2ed025dce2cd9/vendor/tensorflow/models/research/video_prediction/README.md): predicting future video frames with

  neural advection.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.deepdrive.io/vendor/tensorflow/models/research.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
